;Base	b818a

.NOLIST
.LALL
.LFCOND
.NOCREF

.486
.model flat,stdcall
option casemap:none

;;	Includes

include		windows.inc
include		user32.inc
include		kernel32.inc
include		gdi32.inc
include		comdlg32.inc
includelib	user32.lib
includelib	kernel32.lib
includelib	gdi32.lib
includelib	comdlg32.lib	;paths set in c:\aw.bat

.RADIX	16

;;	Equates and Macros

shift	=	0
flgof	=	0
;BY	EQU	BYTE PTR

ZRF     MACRO   f,bit			;Zero (clear) Flag
        LOCAL   flgof,shift
	IF	bit LT 8
		shift = bit
		flgof = 0
	ELSE
		IF	bit LT 10
			shift = bit-8
			flgof = 1
		ELSE
			IF	bit LT 17
				shift = bit-10
				flgof = 2
			ELSE
				shift = bit -18
				flgof = 3
			ENDIF
		ENDIF
	ENDIF
        and     BYTE Ptr [flg&f+flgof], NOT 1 SHL shift
        ENDM

WinMain	proto :DWORD,:DWORD,:DWORD,:DWORD

;	Window Styles, etc

LfClSty	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS	;Class Style
ChClSty	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS

ChExSty	EQU	WS_EX_ACCEPTFILES or WS_EX_APPWINDOW or WS_EX_CLIENTEDGE
; or\
;		WS_EX_CONTROLPARENT or WS_EX_NOINHERITLAYOUT
;	invoke	CreateWindowEx,ChExSty,esi,edi,ChClSty,edx,edx,edx,edx,\
ChSty	EQU	WS_CHILD or WS_OVERLAPPEDWINDOW


.DATA

;;	Windows System

LFwc	LABEL	DWORD		;LFile Window Class structure
	DD	SIZEOF WNDCLASSEX	; 0 wc.cbSize
	DD	LfClSty			; 4 wc.style
	DD	WProc			; 8 wc.lpfnWndProc
	DD	0,0			;0C wc.cbClsExtra, wc.cbWndExtra
hinst	DD	?			;14 wc.hinst
hicon	DD	?			;18 LoadIcon,0,IDI_APPLICATION
hcurs	DD	?			;1C LoadCursor,NULL,IDC_ARROW
hbkbr	DD	?			;20 CreateSolidBrush,0FF0000h
wcmen	DD	0			;24 wc.lpszMenuName
	DD	ClassName		;28 wc.lpszClassName
hiconsm	DD	?			;2C wc.hIconSm
					;30	end LFwc
LFwcc	LABEL	DWORD		;LFile Window Child Class structure
	DD	SIZEOF WNDCLASSEX	; 0
	DD	ChClSty			; 4
	DD	CWProc			; 8
	DD	0,0			; C
chinst	DD	?			;14 Dwords at 14,18,1C and 2C are copied
	DD	?			;18   from LFwc in neww
	DD	?			;1C 
	DD	?			;20 From CreateSolidBrush,0EEEE00
	DD	0			;24
	DD	ChldClass		;28 ClassName
	DD	?			;2C

ClassName	DB	"LFclass",0
AppName		DB	"testp b811",0

ChldClass	DB	"LFChildclass",0
ChildW		DB	"lfwChild",0,0

font1	LABEL	DWORD	;typedef struct tagLOGFONT {
	DD	?	; 0  LONG lfHeight
	DD	?	; 4  LONG lfWidth
escp	DD	0	; 8  LONG lfEscapement;
orie	DD	0	; C  LONG lfOrientation;
wght	DD	240	;10  LONG lfWeight;
ital	DB	0	;14  BYTE lfItalic;
undl	DB	0	;15  BYTE lfUnderline;
strk	DB	0	;16  BYTE lfStrikeOut;
chst	DB	OEM_CHARSET	;17  BYTE lfCharSet	-1 = OEM_CHARSET
opre	DB	0	;18  BYTE lfOutPrecision	\
cpre	DB	0	;19  BYTE lfClipPrecision	 0 = default
qual	DB	0	;1A  BYTE lfQuality		/
pfam	DB	FIXED_PITCH or FF_MODERN	;1B  BYTE lfPitchAndFamily
face	DB	"OEM_FIXED_FONT",0	;1C
			;2B  font1 ends
	ALIGN
;;	Display

msdat	LABEL	BYTE		;Main Screen DATA

	DB	"0          Testing Child Window Creation, etc",0
	DB	"1 23456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef",0
	DB	"2",0
	DB	"3 sszh = screen size vertical = 50",0
	DB	"4 sszv = screen size vertical = 20",0
	DB	"5",0
	DB	"6    Commands in Main Window:",0
	DB	"7       escape - exit",0
	DB	"8       w - open child Window",0
	DB	"9       back - beep",0
	DB	"a       r - Refresh Screen",0
	DB	"b       t - Test MessageBox",0
	DB	"c",0
	DB	"d    Commands in Child Window:",0
	DB	"e       escape - exit",0
	DB	"f       back - Return to Main Window *** In Debug",0
	DB	"10      keypad 1 - double Beep (so you know you're in the Child)",0
	DB	"11      Other keys - single Beep",0
	DB	"12",0
	DB	"13  The stuff at the bottom is not relevant now",0
	DB	"14",0
	DB	"15",0
	DB	"16  All seems well in Main Window",0
	DB	"17  Press 'w' to enter child",0
	DB	"18  Child window is undeveloped, but it seems to process",0
	DB	"19  keyboard input as expected.",0
	DB	"1a",0
	DB	"1b  The problem is that after 'back' returns keyboard focus",0
	DB	"1c  to the main window, the main window does not redisplay.",0
	DB	"1d",0
	DB	"1e",0
	DB	"1f",0
	DB	"20",0
	DB	"21        Debug Window for keytest",0
	DB	"22",0
	DB	"23  virtual  scancode Ascii    Ext  Shft ctrl alt",0
	DB	"24",0
	ALIGN

sszh	DD	50	;Screen SiZe Horizontal - columns
fsszv	DD	25	;Full Screen SiZe Vertical - lines
msszv	DD	21	;Main Screen SiZe Vertical - lines
scrbf	DB	50*25 DUP (" ")	;screen buffer, 25 rows, 50 columns

flgs	DD	0	;System internal - bits 12 - 14 used here
; s,10	reserved	test BYTE PTR [flgs+2],0
; s,11	reserved			2
; s,12	Child Class Registered		4
; s,13	Child Exists			8
; s,14	Child Active			10

;;	Debug & Misc Strings

mbcap	DB	"Error",0		;Message Box Caption
mb1	DB	"So far, so good",0
cap1	DB	"Testing MessageBox",0
.DATA?

;	Handles and Procedure variables

hdc	DD	?	;Handles to Device Context
;ghwnd	DD	?	;	to main window
cfown	DD	?	;	to window owner? main w
hfont1	DD	?	;	to font1

cwhpos	DD	?	; Child Window Horizontal POSition - logical units
cwvpos	DD	?	; Child Window Vertical POSition
cwszh	DD	?	; Child Window SiZe Vertical
cwszv	DD	?	; Child Window SiZe Horizontal
rect	LABEL	DWORD	;No separate rect for child for now.
r_lft	DD	?	;00 When we have chars in the child
r_top	DD	?	;04 we'll use the same char cell sizes.
r_rgt	DD	?	;08
r_bot	DD	?	;0C

cszh	DD	?	;Char cell SiZe Horizontal
cszv	DD	?	;Char cell SiZe Vertical

cmdl	DB	40 DUP (?)	;not used - 

ps	LABEL	DWORD	;PAINTSTRUCT
	DD	10 DUP (?)

erbf	DB	200 DUP (?)

.CODE

;;;	Initialize, Winmain

;;-	Init

;   start:	Initialize LFwc		(5 handles)

start:
	invoke	CreateSolidBrush,0FF0000h
	mov	[hbkbr], eax

	invoke	LoadIcon,0,IDI_APPLICATION
	mov	[hicon], eax
	mov	[hiconsm], eax

	invoke	LoadCursor,0,IDC_ARROW
	mov	[hcurs], eax

	invoke	GetModuleHandle, 0
	mov	[hinst], eax

;		invoke WinMain,hinst,hprev,cmdl,SW_SHOWDEFAULT

	invoke	WinMain,hinst,0,OFFSET cmdl,SW_SHOWDEFAULT

	invoke	ExitProcess,eax

;;-	winmain

;   WinMain	proc hInst,hPrevinst,CmdLine:LPSTR,CmdShow	!RegisterClass

WinMain proc hInst,hPrevinst,CmdLine:LPSTR,CmdShow
LOCAL	msg:MSG
LOCAL	hwnd:HWND

	invoke	RegisterClassEx, OFFSET LFwc

;		edx  CW_USEDEFAULT	!CreateWindowEx

	mov	edx, CW_USEDEFAULT

	invoke	CreateWindowEx,WS_EX_APPWINDOW,ADDR ClassName,ADDR AppName,\
	WS_OVERLAPPEDWINDOW,edx,edx,edx,edx,0,  0,hInst,0
;			    \x, y, szh, szv/^par^men/	^lparam
;		eax=0 => germs2		[hwnd*],[cfown]  eax	!ShowWindow

	or eax, eax
	  jz	germs2
	mov	[hwnd], eax

	mov	[cfown], eax

	invoke	ShowWindow,hwnd,SW_SHOWMAXIMIZED
;		call gsva		!UpdateWindow,hwnd

	call	gsva				;Get Screen VAriables

	invoke UpdateWindow, hwnd
;		loop get/xlate/dispatch til eax=0

	.while TRUE
		invoke GetMessage, ADDR msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
;		eax  msg.wParam	ret

	mov   eax,msg.wParam

	ret


;   gsva:       !GetClientRect          eax <- [r_bot]\BY [fsszv]

gsva:
	invoke	GetClientRect,hwnd,ADDR rect	;Get Screen VAriables

	mov	eax, [r_bot]
	div	BYTE PTR [fsszv]

;               eax,[cszv] <- al        eax <- [r_rgt]\BY [sszh]

	movzx	eax, al
	mov	[cszv], eax		;Character Cell SiZe Vertical

	mov	eax, [r_rgt]
	div	BYTE PTR [sszh]

;               eax,[chzh] <- al	retn

	movzx	eax, al
	mov	[cszh], eax		;Character Cell SiZe Horizontal
	retn

;;	GERMS2		Get ERror MeSsage 2	use msgbx

;   germs2:	invoke getlasterror	!FormatMessage,sys,,eax,0,erbf,bfsz,0

germs2:
	invoke	GetLastError

	xor	edx, edx
	mov	esi, OFFSET erbf
	invoke	FormatMessage,1000,edx,eax,edx, esi,100,edx

	invoke	MessageBox,0, esi,0, MB_CANCELTRYCONTINUE

	retn

;i:\sandbox\testnote.lfw has notes

;		!MessageBox,hwnd,ADDR erbf,ADDR mbcap,MB_CANCELTRYCONTINUE

	invoke	MessageBox, hwnd, ADDR erbf, ADDR mbcap, MB_CANCELTRYCONTINUE
;			    ^own  ^txt	     ^cap	  ^type
;		int 3			retn

	int	3

	retn


WinMain endp
;;;	WProc - Main Windows Procedure
;;		- Init, Messages, exit

;   WProc	proc wp_hWnd,uMsg,wParam,lParam			eax <- [uMsg]

WProc proc wp_hWnd,uMsg,wParam,lParam
	pushad

	mov	eax, [uMsg]		;message handling
;		edx <- [wParam]		ecx <- [lParam]

	mov	edx, [wParam]
	mov	ecx, [lParam]
;		eax<>_DESTROY => @F	!PostQuitMessage	jmp WPend

	cmp	eax, WM_DESTROY
	  jnz	@F

WPdes:	invoke	PostQuitMessage,NULL
	  jmp	WPend
;   @@:		eax<>_PAINT => @F	call dspl		jmp WPend

@@:
	cmp	eax, WM_PAINT
	  jnz	@F

	call	dspl

	  jmp	WPend
;   @@:		eax=_KEYDOWN => key	eax<>_SETFOCUS => @F

@@:
	cmp	eax, WM_KEYDOWN
	  jz	key

	cmp	eax, WM_SETFOCUS
	  jnz	@F
;		~QF s,13 => WPend	!UpdateWindow		jmp WPend

	test	BYTE PTR [flgs+2],8	;s,13  child exists
;	  jz	WPend

;	invoke UpdateWindow, wp_hWnd
;	invoke	SetActiveWindow,wp_hWnd
;	invoke	SetForegroundWindow, wp_hWnd
;	invoke	ShowWindow,wp_hWnd,SW_SHOW
;	invoke InvalidateRect,wp_hWnd,0,0

;	  jmp	WPend

;   @@:		popad			!DefWindowProc		ret

@@:
	popad

	invoke	DefWindowProc,wp_hWnd,uMsg,wParam,lParam

	ret				;one of two rets from wproc

;   WPend:	popad			eax  0			ret

WPend:	popad

	xor	eax,eax

	ret

;   WPinv	(tries that crashed)	jmp WPend

WPinv:
;	invoke UpdateWindow, wp_hWnd
;	invoke InvalidateRect,wp_hWnd,0,0

	  jmp	WPend

;;		- Key

;   key:	dl=escape => WPdes	dl="w" => neww	dl<>back => @F

key:
	cmp	dl, 1Bh		;escape
	  jz	WPdes

	cmp	dl, 57		;w
	  jz	neww
	cmp	dl, 8		;back
	  jnz	@F
;		!Beep,0B00,0B0		jmp WPend

	invoke	Beep, 0B00,0B0
	  jmp	WPend
;   @@:		dl<>"r" => @F		jmp WPinv

@@:
	cmp	dl, 52		;r
	  jnz	@F

	  jmp	WPinv
;   @@:		dl<>"t" => WPinv	call testMB		jmp WPend

@@:
	cmp	dl, 54		;t
	  jnz	WPinv

	call	testMB

	  jmp	WPend

;;		- DSPL  Main Display

;   dspl:	!BeginPaint		[hdc]  eax		edi  font1

dspl:	invoke	BeginPaint,wp_hWnd,ADDR ps		;fills (ps) w/ defaults

	mov	[hdc], eax

	mov	edi, OFFSET font1
;		eax  [cszv]		[edi]  eax		eax  [cszh]-1

	mov	eax, [cszv]

	mov	[edi], eax		;height in font1

	mov	eax, [cszh]
	dec	eax
;		[edi+4]  eax		!CreateFontInd		[hfont1]  eax

	mov	[edi+4], eax		;width in font1

	invoke	CreateFontIndirect,edi

	mov	[hfont1], eax
;		!SelectObject		call dspl_0

	invoke	SelectObject,hdc,eax

	call	dspl_0
;		!EndPaint		retn

	invoke	EndPaint,wp_hWnd,ADDR ps

	retn

;   _0:		!set colors white/blue	call wscbf		esi  scrbf

dspl_0:
	invoke	SetTextColor,hdc,0FFFFFF
	invoke	SetBkColor,hdc,0FF0000		;set screen colors white on blue

	call	wscbf			;write data to scrbf
					;this 2-step process is looking ahead
					;  to when there are more data sources
	mov	esi, OFFSET scrbf
;		ecx  [msszv]		edi,ebx  0		call _cx

	mov	ecx, [msszv]

	xor	edi, edi		;vertical position, logical units
	mov	ebx, edi		;horizontal position
;	add	edi, [cszv]		;??? If edi starts at 0, as it should,
;	dec	edi			;??? all's fine except titlebar over-
	;writes line 0.  W/ this I don't get a title bar til I open and close\
	;the child - need invalidaterect?

	call	dspl_cx
;		set colors black/white	ecx  4		fallthru to _cx

	invoke	SetTextColor,hdc,0
	invoke	SetBkColor,hdc,0FFFFFF		;

;	mov	BY [cntr], 4
	mov	ecx, 4


;   _cx:	push ecx		!TextOut		add edi, [cszv]

dspl_cx:
	push	ecx

	invoke	TextOut,hdc,ebx,edi,esi,[sszh]

	add	edi, [cszv]		;each line is cszv in height
;		add esi, [sszh]		pop ecx

	add	esi, [sszh]

	pop	ecx

cmp ecx,1
ja @F
nop		;debug
@@:
;		loop _cx		retn

	loop	dspl_cx

	retn
;;		-- WSCRBF	Write SCreen BuFfer

;   wscbf:	esi  msdat		edi  scrbf		edx  [msszv]

wscbf:
	mov	esi, OFFSET msdat

	mov	edi, OFFSET scrbf

	mov	edx, [msszv]
	mov	edx, [fsszv]
;   _lp0:	ecx  [sszh]		call _lp		dec edx

wscbf_lp0:
	mov	ecx, [sszh]

	call	wscbf_lp

	dec	edx
;		jnz _lp0		retn

	  jnz	wscbf_lp0

	retn

;   _lp:	lodsb			al=0 => _lpe		stosb

wscbf_lp:
	lodsb

	or	al, al
	  jz	wscbf_lpe

	stosb
;		loop _lp		inc esi

	loop	wscbf_lp

	inc	esi		;skip the "0" if there are sszh chars (line
				;ends flush
;   _lpe:	add edi, ecx		retn

wscbf_lpe:
	add	edi, ecx
	retn


;;	NEWW	NEW child Window

;   neww:	QF s,12 => _0		esi  hinst		edi  chinst

neww:	test	BYTE PTR [flgs+2],4		; s,12 Is class registered?
	  jnz	neww_0

	mov	esi, OFFSET hinst	;LFwc+14

	mov	edi, OFFSET chinst
;		ecx  3			rep movsd		eax  [esi+0C]

	mov	ecx, 3

	rep	movsd			;hinst,hicon,hcurs

	mov	eax, [esi+0C]		;hiconsm
;		[edi+0C]  eax		!CreateSolidBrush	[edi]  eax

	mov	[edi+0C], eax		;- copy main window's values

	invoke	CreateSolidBrush,0EEEE00

	mov	[edi], eax		;edi left at LFwcc +14+0C = 20
;		!RegisterClassEx LFwcc	eax=0 => @F

	invoke	RegisterClassEx, OFFSET LFwcc

	or	eax, eax
	  jnz	@F
;		!Beep 0B00,0B0		retn

	invoke	Beep,0B00,0B0

	retn
;   @@:		SFL s,12

@@:	or	BYTE PTR [flgs+2],4		;s,12 - child class registered
;   neww_0:	edx  CW_USEDEFAULT	eax  0			esi  ChldClass

neww_0:
	mov	edx, CW_USEDEFAULT

	xor	eax,eax

	mov	esi, OFFSET ChldClass
;		edi  ChildW		!CreateWindowEx		eax<>0 => @F

	mov	edi, OFFSET ChildW

;	Init data

;		eax,[cwhpos]  18*[cszh]	eax,[cwvpos]  10*[cszv]

	xor	eax,eax
	mov	al, 18
	mul	BYTE PTR [cszh]
	mov	[cwhpos], eax
	mov	eax, 10
	mul	BYTE PTR [cszv]
;		eax,[cwszh]  20*[cszh]		eax,[cwszv]  8*[cszv]

	mov	[cwvpos], eax
	mov	eax, 20
	mul	BYTE PTR [cszh]
	mov	[cwszh], eax
	mov	eax, 8
	mul	BYTE PTR [cszv]
	mov	[cwszv], eax

	invoke	CreateWindowEx,0,esi,edi,0,\
	200,200,100,100,wp_hWnd,0,hinst,0

	or	eax, eax
	  jnz	@F
;		!Beep			!ShowWindow,eax		jmp WPend

	invoke	Beep,0B00,0B0

@@:	invoke	ShowWindow,eax,SW_SHOWNORMAL

	  jmp	WPend

	WProc endp

;;;	CWProc

;   CWProc	proc cwphw,msg,wparam,lparam			pushad

CWProc proc cwphw,msg,wparam,lparam

	pushad
;		SFl s,13;s,14		edx  [wparam]		ecx  [lparam]

	or	BYTE PTR [flgs+2],18	; s,13 & s,14 child exists and active

	mov	edx, [wparam]

	mov	ecx, [lparam]
;		eax  [msg]		eax<>WM_DESTROY => _des

	mov	eax, [msg]

	cmp	eax, WM_DESTROY
	  jz	CWP_des
;		eax=WM_PAINT => _pai	eax=WM_KEYDOWN => ckey

	cmp	eax, WM_PAINT
	  jz	CWP_pai

	cmp	eax, WM_KEYDOWN
	  jz	ckey
;   _def	!DefaultWindowProc	popad			ret

	invoke	DefWindowProc,cwphw,msg,wparam,lparam

	popad

	ret				;one of two rets from CWProc
;   _end:	popad			eax  0			ret

CWP_end:
	popad

	xor	eax,eax

	ret				;the other

;   _des:	!PostQuitMessage,cwphw	ZRF s,13;s,14		jmp _end

CWP_des:
	invoke	DestroyWindow,cwphw

	and	BYTE PTR [flgs+2],not 18	; s,13 & 14

	  jmp	CWP_end
;   _pai:	call cdspl		jmp _end

CWP_pai:
	call	cdspl

	  jmp	CWP_end

;;	CKEY	Child KEY functions

;   ckey:	dl=esc => CWP_des	dl=back => _par

ckey:
	cmp	dl, 1Bh		;escape
	  jz	CWP_des

	cmp	dl, 8		;back
	  jz	ckey_par
;		dl=ky1 => _test		Beep			jmp CWP_end

	cmp	dl, 23		;keypad 1
	  jz	ckey_test

	invoke	Beep,0B00,0B0

	  jmp	CWP_end

;   _test:	Beep			Beep			jmp CWP_end

ckey_test:
	invoke	Beep,0900,090
	invoke	Beep,0B00,0B0

	  jmp	CWP_end

;   _par:	!SetFocus,cfown		eax<>0 => @F		Beep

ckey_par:
;	invoke	SetFocus,cwphw
	invoke	SetFocus,cfown

	or	eax, eax
	  jnz	@F

	invoke	Beep,0800,0B0
;		ZRF s,14		jmp CWP_end

@@:
	and	BYTE PTR [flgs+2],not 10	;s,14  child not active

	  jmp	CWP_end

cdspl:
	retn

	CWProc endp

;;;	Misc Global Routines

;;	testMB		testMessageBox

;   testMB:	esi  mb1		edi  cap1

testMB:
	mov	esi, OFFSET mb1
	mov	edi, OFFSET cap1

;	invoke	MessageBox, 0, esi, edi, MB_CANCELTRYCONTINUE

	invoke	MessageBox,0,    esi, edi, MB_CANCELTRYCONTINUE
;			   ^own  ^txt ^cap  ^type

	retn

	END	start